unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

function GetCounter(const S: string): Integer;
var
  NumStr: string;
  TmpStr: string;
  C:      Char;
begin
  Result := 0;
  if RightStr(S, 1) <> ')' then Exit;

  NumStr := '';
  TmpStr := S;
  repeat
    TmpStr := LeftStr(TmpStr, Length(TmpStr)-1);
    C      := S[Length(TmpStr)];
    if (C < '0') or (C > '9') then Break;
    NumStr := C + NumStr;
  until False;

  if TryStrToInt(S, Result) then Exit;
  Result := 0;
end;

function NewFile1(const S: string): string;
var
  Name:      string;
  Extension: string;
  Tail:      string;
  Counter:   Integer;
begin
  Result    := '';
  Extension := ExtractFileExt(S);
  Name      := LeftStr(S, Length(S)-Length(Extension));
  Counter   := 0;
  repeat
    case Counter > 0 of
      True:  Tail := ' (' + Counter.ToString + ')';
      False: Tail := '';
    end;
    if not(FileExists(Name + Tail + Extension)) then
    begin
      Result := Name + Tail + Extension;
      Exit
    end;
    if Counter >= MaxInt then Exit;
    Inc(Counter);
  until False;
end;

function NewFile2(const S: string): string;
var
  Name:      string;
  Extension: string;
  Tail:      string;
  Counter:   Integer;
begin
  Result    := '';
  Extension := ExtractFileExt(S);
  Name      := LeftStr(S, Length(S)-Length(Extension));
  Counter   := GetCounter(Name);
  repeat
    case Counter > 0 of
      True:  Tail := ' (' + Counter.ToString + ')';
      False: Tail := '';
    end;
    if not(FileExists(Name + Tail + Extension)) then
    begin
      Result := Name + Tail + Extension;
      Exit
    end;
    if Counter >= MaxInt then Exit;
    Inc(Counter);
  until False;
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowMessage(NewFile1('project1.lpi'));
  ShowMessage(NewFile2('project1.lpi'));
end;

end.
